/* C-family support for MSP430 back end.
   
Copyright (C) 2012 Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 3, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tree.h"
#include "tm.h"
#include "tm_p.h"
#include "target.h"
#include "output.h"
#include "c-family/c-common.h"
#include "c-family/c-pragma.h"
#include "intl.h"
#include "diagnostic.h"

#define GCC_BAD(gmsgid) \
  do { warning (OPT_Wpragmas, gmsgid); return; } while (0)
#define GCC_BAD2(gmsgid, arg) \
  do { warning (OPT_Wpragmas, gmsgid, arg); return; } while (0)

void
msp430_pr_vector (cpp_reader * reader ATTRIBUTE_UNUSED)
{
  enum cpp_ttype token;
  bool need_close_paren = false;
  tree x;
  tree t;

  if (pragma_lex (&t) != CPP_EQ)
    GCC_BAD ("missing %<=%> after %<#pragma vector%> - ignored");
  token = pragma_lex (&t);
  if (token == CPP_OPEN_PAREN)
    {
      token = pragma_lex (&t);
      need_close_paren = true;
    }
  if (token != CPP_NUMBER)
    GCC_BAD ("malformed %<#pragma vector%> - ignored");
  if (TREE_CODE (t) != INTEGER_CST)
    GCC_BAD ("invalid constant in %<#pragma vector%> - ignored");
  if (need_close_paren && pragma_lex (&x) != CPP_CLOSE_PAREN)
    GCC_BAD ("malformed %<#pragma vector%> - ignored");
  msp430_vector_offset_tree = t;
}
